    processor 6502
    include vcs.h
    org $F000
Scanline = $80
CountSet = $81
CountYHold = $82

LastYC = $83
LastPF = $84
BKColor = $85
BallVPos = $86
BallQuit = $87
BallHPos = $88
SMove = $89
PFBallOnOff = $8A

Number = $8B
NStor = $8C

LTHs1 = $8D
LTHs2 = $8E
LTHs3 = $8F
LTHs4 = $90
LTHs5 = $91

RTHs1 = $92
RTHs2 = $93
RTHs3 = $94
RTHs4 = $95
RTHs5 = $96

LTOs1 = $97
LTOs2 = $98
LTOs3 = $99
LTOs4 = $9A
LTOs5 = $9B

RTOs1 = $9C
RTOs2 = $9D
RTOs3 = $9E
RTOs4 = $9F
RTOs5 = $A0

B0VPos = $A1
B0Quit = $A2
B0HPos = $A3
B0On   = $A4

B1VPos = $A5
B1Quit = $A6
B1HPos = $A7
B1On   = $A8

P0aVPos = $A9
P0aQuit = $AA
P0aHPos = $AB
P0aOn   = $AC

P1aVPos = $AD
P1aQuit = $AE
P1aHPos = $AF
P1aOn   = $B0

P0bVPos = $B1
P0bQuit = $B2
P0bHPos = $B3
P0bOn   = $B4

P1bVPos = $B5
P1bQuit = $B6
P1bHPos = $B7
P1bOn   = $B8

P0SCTh = $B9
P0SCHu = $BA
P0SCTe = $BB
P1SCTh = $BC
P1SCHu = $BD
P1SCTe = $BE

BallDir = $BF
BallVDir = $C0

Start
        SEI
        CLD
        LDX  #$FF
        TXS
        LDA  #0
ClearMem
        STA 0,X
        DEY
        BNE ClearMem
        LDA #$00
        STA COLUBK
        LDA #$0E
        STA COLUPF
	LDA #$34
	STA COLUP0
	LDA #$74
	STA COLUP1
	LDA #192
	STA Scanline
	JSR CenterPF ; line up playfield
;104
;MainLoop
VSyncSetup

	LDA #2
	STA VSYNC
	STA WSYNC
	STA WSYNC

	LDA SMove        ;if SMove is set to 1 then it's
	CMP #1           ;ok to move the playfield ball
	BEQ StartMoves
	JMP SkipGM       ;else skip over the move information

StartMoves
	STA WSYNC
	STA HMOVE
	LDA #43
	STA TIM64T

	LDA BallDir      ;if ball direction is 0 then
	CMP #0           ;skip to SkipGMWysunc
	BNE LeftOrRight
	JMP SkipGMWsync
LeftOrRight
	CMP #$F0		;if ball direction equals -1
	BNE SkipAdd     ;then skip to SkipSub
	INC BallHPos    ;increase ball pos by 1
	JMP SkipSub     ;jump to SkipSub
SkipAdd
	DEC BallHPos    ;decrease ball pos by 1

SkipSub
	LDA BallHPos    ;if ball pos = 156
	CMP #156        ;then change dir to move left
	BNE SkipChangeToLeftM ;else evaluate for left
	LDA #$10              ;movement
	STA BallDir
	JMP VPFMovement ;jump to SCTRM
;139
SkipChangeToLeftM
	LDA BallHPos
	CMP #-2         ;if ball pos = -2
			      ;change dir to move right
	BNE VPFMovement ; else dont move
	LDA #$F0
	STA BallDir
;SkipChangeToRightM

VPFMovement
	LDX CountSet
	CPX #0
	BNE CheckBottom
	LDA CountYHold
	CMP count,X
	BNE MiddleCheck
	LDA BallVPos
	CMP #160
	BNE CXS00
	LDA #-1
	STA BallVDir
	DEC BallVPos
	DEC BallQuit
	JMP SkipGMWsync

DownAllowed
	LDY CountYHold
	LDX CountSet
	CPY #1
	BNE DoAl
NewYLoad
	INX
	LDY count,X
	STX CountSet
	STY CountYHold
	JMP SkipGMWsync
DoAl
	DEY
	STY CountYHold
	JMP SkipGMWsync

SendDCenter
	LDA BallVPos
	CMP #85
	BNE SDC
ScrollDown
	LDY LastYC
	LDX LastPF
	CPX lineSets
	BNE DownAllowed
	CPY #0
	BNE DownAllowed
	JMP SkipGMWsync
SDC
	DEC BallVPos
	DEC BallQuit
	JMP SkipGMWsync

CXS00
	LDA BallVDir
	CMP #1
	BNE SendDCenter
	INC BallVPos
	INC BallQuit
	JMP SkipGMWsync

CheckBottom
	LDA LastPF
	CMP lineSets
	BNE MiddleCheck
	LDA LastYC
	CMP #0
	BNE MiddleCheck
	LDA BallVPos
	CMP #5
	BNE CSXLS
	LDA #1
	STA BallVDir
	INC BallVPos
	INC BallQuit
	JMP SkipGMWsync

MiddleCheck
	LDA BallVDir
	CMP #1
	BEQ ScrollUp
	CMP #-1
	BEQ ScrollDown
	JMP SkipGMWsync

UpAllowed
	CMP count,X
	BNE UpAl
NewYUSLoad
	DEX
	LDY #1;count,X
	STX CountSet
	STY CountYHold
	JMP SkipGMWsync
UpAl
	INY
	STY CountYHold
	JMP SkipGMWsync

SendUCenter
	LDA BallQuit
	CMP #81
	BNE SUC
ScrollUp
	LDY CountYHold
	LDX CountSet
	TYA
	CMP count,X
	BNE UpAllowed
	CPX #0
	BNE UpAllowed
	JMP SkipGMWsync
SUC
	INC BallVPos
	INC BallQuit
	JMP SkipGMWsync

CSXLS
	LDA BallVDir
	CMP #-1
	BNE SendUCenter
	DEC BallVPos
	DEC BallQuit
      JMP SkipGMWsync

SkipGM
	  STA WSYNC
        LDA #43
        STA TIM64T

SkipGMWsync
        LDA #0
        STA VSYNC
        STA PF0
        STA PF1
        STA PF2
	  STA ENABL

	  LDA #-1
	  CMP LastPF
	  BEQ VBlankWait

;StartButton
	  LDA INPT4
	  BMI VBlankWait
	  LDA #1
	  STA SMove


VBlankWait
        LDA #0
        LDA INTIM
        BNE VBlankWait
	  LDY #31
	  LDX #4
        STA WSYNC
        STA VBLANK
	  STA WSYNC
	  STA WSYNC
	  LDA #$00
        STA COLUBK

	  STA WSYNC
ScoreKernal
	  LDA #$10
        STA COLUBK
	  LDA #$A8
	  STA BKColor
	  STA WSYNC
        LDA #3
        STA CTRLPF
Score1
      DEC Scanline
	DEY
	STA WSYNC
	LDA LTHs1
	STA PF1
	LDA RTHs1
	STA PF2
	DEX
	CPX #0
	BNE Score1
	LDX #4

Score2
      DEC Scanline
	DEY
	STA WSYNC
	LDA LTHs2
	STA PF1
	LDA RTHs2
	STA PF2
	DEX
	CPX #0
	BNE Score2
	LDX #4

Score3
      DEC Scanline
	DEY
	STA WSYNC
	LDA LTHs3
	STA PF1
	LDA RTHs3
	STA PF2
	DEX
	CPX #0
	BNE Score3
	LDX #4

Score4
      DEC Scanline
	DEY
	STA WSYNC
	LDA LTHs4
	STA PF1
	LDA RTHs4
	STA PF2
	DEX
	CPX #0
	BNE Score4
	LDX #4

Score5
      DEC Scanline
	DEY
	STA WSYNC
	LDA LTHs5
	STA PF1
	LDA RTHs5
	STA PF2
	DEX
	CPX #0
	BNE Score5
	STX PF1
	STX PF2

WaistLines
	DEC Scanline
	STA WSYNC
	DEY 
	CPY #0
	BNE WaistLines
	DEC Scanline
	STA WSYNC
	LDX CountSet
	LDY CountYHold
	JMP QuickDec
;	JMP QuickLoad
;212
DrawPlayfield
	DEC Scanline
	CPY #0
	BEQ ChangeX
	STA WSYNC
	LDA PFBallOnOff
	STA ENABL
	DEY
	JMP ScanlineCheck

EnablePFBall
	LDA #2
	STA PFBallOnOff
	JMP DrawPlayfield

DisablePFBall
	LDA #0
	STA PFBallOnOff
	JMP DrawPlayfield

QuickDec
	DEC Scanline
	DEY
      LDA #$11
      STA CTRLPF
	JMP QuickLoad

ChangeX
	INX
	LDY count,X

QuickLoad
	STA WSYNC
      LDA BKColor
      STA COLUBK
	LDA left_pf0,X
	STA PF0
	LDA PFBallOnOff
	STA ENABL
	LDA left_pf1,X
	STA PF1
	LDA left_pf2,X
	STA PF2

ScanlineCheck
      LDA Scanline
	CMP #0
	BEQ End
	CMP BallVPos
	BEQ EnablePFBall
	CMP BallQuit
	BEQ DisablePFBall
	JMP DrawPlayfield

End
        LDA #2
        STA WSYNC
        STA VBLANK
	  LDA #192
	  STA Scanline
	  STX LastPF
	  STY LastYC
        STA WSYNC
	  LDA BallDir
	  STA HMBL

ContOver
      LDY #30;29

OverScan
        STA WSYNC
        DEY
	  CPY #0
        BNE OverScan
	  STY ENABL
        JMP VSyncSetup

CenterPF
	LDA halfValue
	STA CountSet
	LDX #0
	LDY count,X

CountDown
	LDA CountSet
	CMP #0
	BEQ PFScreenAdjust
	CPY #1
	BEQ Increase; increase X register
;300
	DEC CountSet
	DEY
	JMP CountDown

Increase
	INX
	LDY count,X
	JMP CountDown

PFScreenAdjust
	LDA count,X
	STA CountYHold
	LDA halfScreen
	STA CountSet

CountUp
	LDA CountSet
	CMP #0
	BEQ SaveStartPF
	CPY CountYHold
	BEQ Decrease
	DEC CountSet
	INY
	JMP CountUp

Decrease
	DEX
	LDY #1
	LDA count,X
	STA CountYHold
	JMP CountUp

SaveStartPF
	STX CountSet
	STY CountYHold
	LDA #-1
	STA LastYC
	STA LastPF
	STA BallVDir
	LDA #0
	STA BallHPos
	LDA #$10
	STA HMBL
	STA BallDir
	LDX #79;(31x7)+4
BallCenter
     STA WSYNC
	STA HMOVE
	INC BallHPos
	DEX
	CPX #0
	BNE BallCenter
	LDA #85
	STA BallVPos
	LDA #81
	STA BallQuit
SetAllScoresZero
	LDX #0
	LDA zero,X
	ASL
	ASL
	ASL
	ASL
	ORA zero,X
	STA Number
	JSR ReverseByte
	STA LTHs1

	LDA zero,X
	ASL
	ASL
	ASL
	ASL
	ORA zero,X
	STA RTHs1

;	LDX #0
;	LDA zero,X
;	ASL
;	ASL
;	ASL
;	ASL
;	ORA zero,X
;	STA Number
;	JSR ReverseByte
;	STA LTOs1

;	LDA zero,X
;	ASL
;	ASL
;	ASL
;	ASL
;	ORA zero,X
;	STA RTOs1
	INX;INCREASE TO 1

	LDA zero,X
	ASL
	ASL
	ASL
	ASL
	ORA zero,X
	STA Number
	JSR ReverseByte
	STA LTHs2

	LDA zero,X
	ASL
	ASL
	ASL
	ASL
	ORA zero,X
	STA RTHs2
	INX; INCREASE TO 2

	LDA zero,X
	ASL
	ASL
	ASL
	ASL
	ORA zero,X
	STA Number
	JSR ReverseByte
	STA LTHs3

	LDA zero,X
	ASL
	ASL
	ASL
	ASL
	ORA zero,X
	STA RTHs3
	INX; INCREASE TO 3

	LDA zero,X
	ASL
	ASL
	ASL
	ASL
	ORA zero,X
	STA Number
	JSR ReverseByte
	STA LTHs4

	LDA zero,X
	ASL
	ASL
	ASL
	ASL
	ORA zero,X
	STA RTHs4
	INX; INCREASE TO 4

	LDA zero,X
	ASL
	ASL
	ASL
	ASL
	ORA zero,X
	STA Number
	JSR ReverseByte
	STA LTHs5

	LDA zero,X
	ASL
	ASL
	ASL
	ASL
	ORA zero,X
	STA RTHs5
;	JSR StackTest
	RTS

ReverseByte
	LDA #0
	STA NStor
	LDY #8

Again
	LDA #$80
	AND Number
	ASL Number
	LSR NStor
	EOR NStor
	STA NStor
	DEY
	CPY #0
	BNE Again
	LDA NStor
	RTS

;StackTest
; LDA #$59
; LTOs1
; LTOs2
; LTOs3
; LTOs4
; LTOs5

; RTOs1
; RTOs2
; RTOs3
; RTOs4
; RTOs5

; B0VPos
; B0Quit
; B0HPos
; B0On  

; B1VPos
; B1Quit
; B1HPos
; B1On  

; P0aVPos
; P0aQuit
; P0aHPos
; P0aOn  

; P1aVPos
; P1aQuit
; P1aHPos
; P1aOn  

; P0bVPos
; P0bQuit
; P0bHPos
; P0bOn  

; P1bVPos
; P1bQuit
; P1bHPos
; P1bOn  

; STA P0SCTh 
; STA P0SCHu 
; STA P0SCTe 
; STA P1SCTh 
; STA P1SCHu 
; STA P1SCTe 
; RTS

left_pf0
  .byte $00;taker 1
  .byte $00; 2
  .byte $00; 3
  .byte $00; 4
  .byte $80; 5
  .byte $80; 5
  .byte $80; 6
  .byte $00; 6
  .byte $00; 7
  .byte $00;taker 1
  .byte $00; 1
left_pf1
  .byte $00;taker 2
  .byte $3F; 2
  .byte $40; 3
  .byte $80; 4
  .byte $00; 5
  .byte $FF; 5
  .byte $00; 6
  .byte $80; 6
  .byte $40; 7
  .byte $3F;taker 2
  .byte $00; 1
left_pf2
  .byte $00;taker 3
  .byte $FF; 2
  .byte $00; 3
  .byte $00; 4
  .byte $00; 5
  .byte $FF; 5
  .byte $00; 6
  .byte $00; 6
  .byte $00; 7
  .byte $FF;taker 3
  .byte $00; 1
count
  .byte $08; 8;taker 4
  .byte $04; 4;taker 4
  .byte $04; 4;taker 4
  .byte $04; 4;taker 4
  .byte $80; 128;taker 4
  .byte $04; 4;taker 4
  .byte $80; 128;taker 4
  .byte $04; 4;taker 4
  .byte $04; 4;taker 4
  .byte $04; 4;taker 4
  .byte $08; 8

halfValue
  .byte $96

halfScreen
  .byte $50

lineSets
  .byte $0A

zero  .byte $07,$05,$05,$05,$07
one   .byte $02,$02,$02,$02,$02
two   .byte $07,$04,$07,$01,$07
three .byte $07,$04,$07,$04,$07
four  .byte $05,$05,$07,$04,$04
five  .byte $07,$01,$07,$04,$07
six   .byte $07,$01,$07,$05,$07
seven .byte $07,$04,$04,$04,$04
eight .byte $07,$05,$07,$05,$07
nine  .byte $07,$05,$07,$04,$04

    org $FFFC
    .word Start
    .word Start